.left margin
.ifnot hlp
.hl 1 DEFINE / RESET
.endif hlp
.lm +5
.if hlp
.i-6;3 DEFINE
.if rsx;Additional help available:
COMMAND	ESCAPE	SUBSCRIPT	SUPERSCRIPT	SUBSTITUTE	VARIABLE__SPACE
.endif rsx
.i-6;4 COMMAND
.endif hlp
.bb
.s.tp5.i-5; _.DEFINE COMMAND /label/command string
.s.x DEFINE>COMMAND
defines commands.  The label is a 10 character command.  The command
must be letters only with no spaces or tabs.  The command string
must be a legal set of commands to be substituted for the label.
For example the following command may be
defined to skip a line indent both margins by 5 spaces and output a centered
line of text.
.s.i5;_.DEFINE COMMAND /HEADERA/s.lm+5.rm-5.c;
.br;The command is _.HEADERA
.p;Notice that the first command is not preceeded by a decimal point
as the command flag is already implied.
Essentially the command string is substituted for the defined command.
This is a special use of the substitute facility.  If you use the
_.RESET SUBSTITUTE command the defined commands are also removed.
The defined commands may be nested to 3 levels the same as substitutions.
.eb
.if hlp.i-6;4 ESCAPE
.endif hlp
.s.tp5.I -5; _.DEFINE ESCAPE "escape label" [,modifiers] definition
.ifnot hlp
.s.x DEFINE>ESCAPE
defines non printing escape sequences for control of a variety of printers.
Each escape sequence is indicated in the text by either _\ or _^  or a symbol
of your choice followed by another symbol.  For example _^* can enable bolding
by issuing a sequence to turn on bolding and _\* may disable bolding by
issuing a turn off sequence.  The escape sequence is entered as follows. 
First you select which 2 character label. The first character must be either
_^,_\, or your flag character, while the second one may be any other
character. They are entered as a literal.  For example the label _^_* may be
entered as "_^_*" or '_^_*' or "_^","_*". Your flag character is defined by
the _.FLAGS ESCAPE command. 
.p
Next the modifiers are entered.  These define how the escape sequence is
handled.  The modifiers are:
.endif hlp
.if hlp
.c; Modifiers
.endif hlp
.lm+5
.i-5; LCK - escape sequence is a lock/unlock pair.
.ifnot hlp
For example if _^_* and _\_* are defined as a lock/unlock pair, then the
first appearance of _^_* will "lock" this feature on and a subsequent
appearance of _^_* will be ignored if _\_* is not used in between them.
Effectively the lock is _^_* and unlock is _\_*.
In addition this allows RNO to control these sequences to prevent them from
acting on the headers.  They will only change the text, much in the same way
the underline flag works.
.bb
Only 16 escape sequences may be declared LCK.
.eb
If a line contains only the "lock" sequence then the unlock sequence will
be automatically output at the end off the line.  The next line will then
automatically be preceeded by the lock sequence.
This continues till the input text contains the "unlock" sequence flag.
If you define a sequence which changes the character style it should
always be defined as a lock/unlock pair.  An example of changed character
style is hardware underlining, shadow printing, bolding, font changes,
or ribbon color changes.
.endif hlp
.i-5; VSP,spacing - escape sequence changes vertical position by spacing.
.ifnot hlp
This allows you to define a sequence which changes the vertical position.
The spacing parameter is specified in half lines with 1 being
1/2 line advance, -1 1/2 line backwards.
.endif hlp
.i-5; HSP,spacing - sequence modifies the horizontal position by spacing.
.ifnot hlp
You may define a sequence which modifies the horizontal position.
.bb
Sequences which modify the position are considered printable characters
,while sequences without HSP are considered attribute changes.  If
a space follows an escape sequence it will be deleted from the output
(while in fill mode) if HSP is not defined.
.eb
.endif hlp
.i-5; PSP - The horizontal spacing specified by HSP is applied to all
printable characters following the escape sequence.
.ifnot hlp
This attribute modifies the HSP attribute.  You can define a sequence
which changes the character width, and let RNO know what the new width is.
The width may only be 0,1,2,... or multiples of the normal width.
If the HSP is specified as a number other than 1, certains aspects of fill
are disabled.  Spaces will not be expanded if necessary to justify.  Only
"normal" spaces with HSP=1 are expanded.  This allows imbedding extra wide
text inside normal text, or centering extra wide text.  A whole line of extra
wide text can not be justified, but a mixed line of normal and wide can
be justified.
This restriction may be removed in future releases of RNO.
.p
.bb
If an escape sequence changes the permanent spacing to a value other than 1
then it should also have the attribute LCK.  Failure to do this will
mess up a varitey of things including underlining and margins.
.eb
.endif hlp
.i-5; CHR - The lock/unlock pair is used to change only 1 printable character.
.ifnot hlp
This attribute is used only if the lock/unlock pair is designed to function
similarly to the underline flag.  You must also declare the escape character
in a _.FLAGS SPECIAL command.
.endif hlp
.lm-5
.ifnot hlp
.p
Then following this the escape sequence is entered.  Printable characters
may be entered as literals ('This is a literl'), while non printable
must be entered as a decimal value..s
The literals may be enclosed in either single (') or double (") quotes.
If a literal is started by a single quote it must be terminated by a single
quote, but it may contain a double quote.  Similarly a literal enclosed
in double quotes may contain a single quote.
The numbers and literals may be separated by blanks,tabs, and or commas.
Two commas in a row constitute a null and are illegal.
If you define an escape sequence twice in your text only the first
definition will be obeyed unless you reset escape before the second one.
The second definition will cause an error message.
.p
If you use a large number of different escape sequences frequently,
you should define the most commonly used ones first.  This will
increase the speed with which RUNOFF can find them.
.bb
.p; Escape sequences can be very trickey. To use them intelligently
the following rules will be helpful.
.list 0
.le Always use LCK and define a lock/unlock pair for a sequence
that changes the text attributes.  Such sequences are ones which
.list 0
.le Change font
.le Change all character spacing
.le Underline characters
.le Change ribbon color
.le Bold or shadow print characters
.els
.le Always define HSP for sequences which output printable characters
.le Always define HSP and PSP for sequences which change the horizontal
character spacing.
.le Always define VSP for sequences which change the vertical postion.
.le Use /UL:L instead of /UL:B for the underlining option especially if
sub or superscripted expressions are to be underlined.  /UL:L is also necessary
if alternate fonts substitute other characters for the underscore.
.le If a font switch results in a pitch change which is not an even multiple
of the normal font, you must handle this change manually.  If such a change
is defines as a lock/unlock pair, RNO will be able to print headers in the old
pitch while using the new one for text.  New margins should be set for the new
pitch, while the old permanent margins are maintained to control the headers.
Underlining will not work properly in the new pitch unless /UL:B is used.
.le If a single font is used throughout then no attributes need be defined
for the font change.
.els 0
.note
Failure to use these suggestions can result in unpredictable results.
.end note
.c;EXAMPLES
.list 1
.le The following example shows
the definition of an escape sequence to turn on bolding, and turn off bolding
for a DIABLO or FLORIDA DATA printer.
.s.tp5.i5; _.DEFINE ESCAPE '_^*',CHR,LCK,27,'W'
.I +5; _.DEFINE ESCAPE '_\*',CHR,LCK,27,'_&'
.i5; _.FLAGS SPECIAL *
.p
The net effect of these definitions is to have _^_* turn on bolding,
_\_* turn off bolding and _* will bold a single character following it.
Bolding will never occurr for titles, page numbers and subtitles.
.le The following shows how to define escape sequences to produce special
symbols.  The extra font is enabled by SO(14) and disabled by SI(15).
.s.i5; _.FLAGS ESCAPE `
.i5; _.DEFINE ESCAPE "`A",SPC,1,14,"A",15
.i5; _.DEFINE ESCAPE "`a",SPC,1,14,"q",15
.i5; _.DEFINE ESCAPE "`_^",SPC,1,14,1,15
.br;If DIABLO style printer is used then each one of these is a correct
definition for a printable special symbol.  The 3 symbols are invoked by
`A, `B, and `_^.
.els 0
.eb
.endif hlp
.if hlp.i-6;4 SUBSTITUTE
.endif hlp
.s.tp 15.i-5; _.DEFINE SUBSTITUTE /label/ text
.x DEFINE>SUBSTITUTE
.s
defines a substitution to be made in the text.
The label is preceeded and followed by a delimiter of your choice.  The label
must be no more than 10 characters long and may not contain spaces or tabs.
The command and the first delimiter must be separated by one or more
spaces or tabs,  but no spaces are necessary after the second delimiter unless
you wish to include them in the text.
When the substitute flag is encountered in your text
followed by a defined label, the specified text will be substituted
for the flag+label.  The text may contain another substitution.
Up to 3 levels of substitution may be nested.
The rules for multiple definitions of escape sequences also apply to
substitutions.
.IF HLP
.if RSX.br;Additional help is available on:
.nf;example	DELIMETERS	LABELS	DSR__CONVENTIONS	WARNING
.f
.endif RSX
.i-6;5 EXAMPLE
.endif hlp
.s; EXAMPLE:
You wish to abbreviate the phrase:
.i 5; The party of the first part
.s;So you define and enable substitution:
.i5; _.DEFINE SUBSTITUTE /P1$/The party of the first part
.i5; _.FLAGS SUBSTITUTE
.s;Then every time you type into the text $P1$ you get instead
the substitute phrase:
.i5;The party of the first part
.if hlp.i-6;5 DELIMITERS
.endif hlp
.br;The example of define substitute could have used different delimiters
if you needed to used the delimiters in the text. For example it could
be done as follows:
.i5; _.DEFINE SUBSTITUTE :P1$:The party of the first part
.I15; _... or
.i5; _.DEFINE SUBSTITUTE "P1$"The party of the first part
.p
.if hlp.i-6;5 LABELS
.br
.endif hlp
The substitution label or name may consist of any printable character.
Upper case or lowercase letters may be used, however the case of the
letter will be ignored except for the first character.  In other words
the following commands are equivalent.
.i5; _.DEFINE SUBSTITUTE /ABC/
.i5; _.DEFINE SUBSTITUTE /Abc/
.i5; _.DEFINE SUBSTITUTE /AbC/
.br;But the following are not equivalent.
.i5; _.DEFINE SUBSTITUTE /aBC/
.i5; _.DEFINE SUBSTITUTE /ABC/
.if hlp.i-6;5 DSR__CONVENTIONS
.endif hlp
.p
A special convention is used to define DSR compatible substitutions.
If the first character of the substitution name is a dollar sign,
the dollar sign stands for
the substitute flag.  If the substitute flag is changed to a character other
than the dollar sign then the defined substitution is considered to begin with
the new substitute flag.  When the substitution is searched for,
the case of the input characters is ignored.
An example of such a substitution is the $$DATE permanently
defined substitution.
.s.lm+10.no fill.i-5; For example the following input:
 _.FLAGS SUBSTITUTE @
 _.DEFINE SUBSTITUTE /$TEST/This is a test
@@test !!
.i-5; Will produce the following line:
 This is a test !!
.lm-10.fill
.ifnot hlp
.p
The substitution is a really invaluable aid for defining
complicated mathematical symbols.  All you need to enter in the text
is the simple abbreviation and the complicated symbol will be
substituted.  The substitution may contain all kinds of escape sequences
overstrike symbols and so on to construct the special symbol needed.
.endif hlp
.if HLP .i-6;5 Warning
.endif HLP
.bb
.note WARNING
You should always define substitutions with labels that do not contain other
substitute labels.  For example the labels ABC and A while unique will cause
you no ends of problems. The first label ABC contains the second label.  As a
result the construction $ABC could be ambiguous. Did you intend the
substitution $A followed by the letters BC or the substitutions $ABC? The easy
way around this problem is to always terminate each substitution with a
terminal character.  It is suggested that the substitute flag character be
used.  You would then define A$ and ABC$ as the labels.  The typist would then
type $ABC$ for one substitution and $A$BC for the other followed by BC. 
.en
.eb
.if hlp.i-6;4 SUBSCRIPT
.endif hlp
.bb
.s.tp5.i-5;_.DEFINE SUBSCRIPT [parameters]
.s.x DEFINE>SUBSCRIPT
This command allows the user to define subscript escape sequences.  This is an
escape sequence that moves the text down 1/2 space on the page.  It must be a
maximum of 10 numbers or characters. The command is followed by either numbers
or literals.  The default is: 
.i5;_.DEFINE SUBSCRIPT 27,"U"
.br;This must be properly defined for equations of half spacing to work.
.if hlp.i-6;4 SUPERSCRIPT
.endif hlp
.s.tp5.i-5;_.DEFINE SUPERSCRIPT [parameters]
.s.x DEFINE>SUPERSCRIPT
This command allows the user to define superscript escape sequences.  This is
an escape sequence that moves the text down 1/2 space on the page.  It must be
a maximum of 10 numbers or characters. The parameters are either number or
literals. The default is: 
.i5;_.DEFINE SUPERSCRIPT 27,"D"
.br;This must be properly defined for equations of half spacing to work.
.if hlp.i-6;4 VARIABLE__SPACE
.endif hlp
.s.tp5.i-5;_.DEFINE VARIABLE SPACE n,[parameters]
.s.x DEFINE>VARIABLE SPACE
This command defines a micro space for implementing variable spacing between
words.  The n is the number of microspaces/space.  The parameters define
an escape sequence which produces a microspace.
The escape sequence may have up to 19 numbers or characters.
The default is:
.i5;_.DEFINE VARIABLE SPACE 6,27,31,3," ",27,31,13
.br;This defines 6 microspaces/space for a DIABLO style printer.
.eb
.if hlp
.i-6;3 RESET
.if rsx;Additional  help available:
ESCAPE	SUBSTITUTE
.endif rsx
.i-6;4 ESCAPE
.endif hlp
.s.tp5.I -5; _.RESET ESCAPE
.s.x RESET>ESCAPE
resets all escape sequences.  This clears the table of escape sequences so you
may enter a new one by using _.DEFINE ESCAPE.
After giving this command all escape sequences are no longer defined.
.if hlp.i-6;4 SUBSTITUTE
.endif hlp
.S.TP 5.I-5; _.RESET SUBSTITUTE
.S.x RESET>SUBSTITUTE
resets the table of substitutions so that all the previous ones are no longer
defined.
The permanently defined substitutions ($$DATE...) and defined commands
are also no longer defined.
.lm
.ifnot HLP.hl 1 MISC COMMANDS
.endif hlp
.lm +5
.if hlp;.i-6;3 REQUIRE
.endif hlp
.s.tp5.I -5; _.REQUIRE 'filename'
.i -5; _.REQ 'filename'
.x REQUIRE
.S
takes the input text from the specified file.  The _.REQUIRE command may be
imbedded in files which have been required.  The required files may be nested
until 5 input files are open at once. An attempt to require a sixth level of
input will cause an error. The default filetype is _.RNO. The filename may be
enclosed in either single (') or double (") quotes. If any commands follow
this command on the same line, they will be ignored. 
.IF HLP
.if RSX.br;Additional help available:
.br;EXAMPLE1	EXAMPLE2
.endif RSX
.i-6;4 EXAMPLE1
.endif hlp
.s
This command makes it easy for you to break up your text into reasonable
chunks.  For example you may wish to put each section in a separate file
and then have a master file which requires each section in order.  If
you need to rearrange the order of the sections you only need to change
the _.REQUIRE statements in the master file.  You also should put the
overall formatting commands such as _.PAGE SIZE, _.DISPLAY, _.HEADER _...
into a separate file which may be required at the beginning of each section.
.p
You may also wish to build up files of commonly used substitutions
and escape sequences.  These can then be easily required at the beginning
of any file that needs them.
.if hlp.i-6;4 EXAMPLE2
.endif hlp
.p
Another example is generation of a series of letters with the same
body but different inside addresses and salutations.  You would
make a master file containing the inside addresses and salutations.
After each salutation you might put:
.i5; _.REQUIRE "LETTER"
.br; You would then create a file LETTER.RNO with the actual text of the
letter. By running the master file through RNO you would get a string of
personalized letters.  Later on you may change the contents of LETTER.RNO to
get another set of personalized letters for mass mailings. 
.if hlp.i-6;3 COMMENT
.endif hlp
.s.tp6.i-5;  _.COMMENT text 
.i-5;_; text 
.s.x COMMENT 
causes the line to be ignored. The text is not printed in the output _.
Comments may contain useful information which you need when re-editing
the file.  For example you may wish to add comments to a string
of _.DEFINE ESCAPE and _.DEFINE SUBSTITUTE to remind you what each
escape sequence and substitution does.
